# Ginbee::WebSocket

CA証明書を指定してサーバ証明書を検証するためのWebSocketライブラリ。

以下のようにca_fileオプションでCA証明書を指定する以外はfaye-websocket
と同様。

```
require "ginbee/web_socket"

EM.run do
  options = {
    ping: 10,
    tls: {
      ca_file: "/path/to/ca.crt",
      cert_chain_file: "/path/to/cert_chain.crt",
      private_key_file: "/path/to/private_key.pem",
      verify_peer: true
    }
  }
  ws = Ginbee::WebSocket::Client.new("wss://example.com", nil, options)
  ...
end
```
