# coding:utf-8
require 'pp'
require 'fileutils'
require 'securerandom'
require 'net/https'
require 'socket'
require 'thread'
require 'logger'
require 'yaml'
require 'json'
require 'socket'
require 'rexml/document'

require_relative "claim-util"

class Claim
  def account(data)
    @conf[:logger].info("claim account start")

    xml = nil
    body = data["body"]
    begin
      xml = make_account_xml(body)
      xml_log("account",xml)
    rescue Exception => ex
      STDERR.puts ex.backtrace
      @conf[:logger].info ex
      @conf[:logger].info ex.backtrace
      raise ex
    end

    return unless xml
    @claim_conf[:servers].each_with_index do |r|
      next unless r[:event].include?("account")
      @conf[:logger].info "send #{r[:name]}"
      res = ERR
      begin
        res = send_claim(r,xml)
        @conf[:logger].info "recv #{h_code(res)}"
      rescue Exception => ex
        STDERR.puts ex
        STDERR.puts ex.backtrace
        @conf[:logger].info ex
      end
    end
    @conf[:logger].info("claim account end")
  end

  def embed_account_xml(jsonstr)
    # parse def file
    var = {}
    deffile = File.join(File.dirname(__FILE__),"template","orca_layout_accounting.def")
    File.read(deffile).split("\n").each do |l|
      r = l.split(",")
      if r[1] == "const"
        var[r[0]] = {"type" => "const", "const" => r[2] }
      elsif r[5]
        var[r[0]] = {"type" => "attr", "attr" => r[5] }
      else
        var[r[0]] = {"type" => "normal"}
      end
    end
  
    # read template
    tmpl = File.join(File.dirname(__FILE__),"template","orca_base_accounting.xml")
    xml = File.read(tmpl)
  
    # convert json to value list
    json = JSON.parse(jsonstr)
    json = json["claim_accountv2res"]
    unless json["Api_Result"] == "00"
      raise "claim api error:#{json["Api_Result_Message"]}"
    end
    json_list = {}
    flatten_json(json_list,"",json)
  
    data = Hash.new("")
    json_list.each do |k,v|
      if %r|^Account_Information\[(\d+)\]\.(.*)| =~ k
        i = $1.to_i + 1
        kk = $2
        if %r|^Medical_Information\[(\d+)\]\.(.*)| =~ kk
          j = $1.to_i + 1
          kkk = $2
          kkk.sub!("ii","%02d"%i).sub!("jj","%02d"%j)
          data["%#{kkk}%"] = v
        else
          kk.sub!("ii","%02d"%i)
          data["%#{kk}%"] = v
        end
      else
        data["%#{k}%"] = v
      end
    end

    # convert
    var.each do |k,v|
      sub = ""
      case v["type"]
      when "const"
        sub = v["const"]
      when "attr"
        if data[k] && !data[k].empty?
          sub = %| #{v["attr"]}="#{data[k]}"|
        else
          sub = ""
        end
      else
        sub = data[k]
      end
      xml.sub!(k,sub)
    end
  
    doc = REXML::Document.new(xml,{:compress_whitespace => :all})
    canonicalize(doc.root)
    xml = doc2xml(doc)
  end
  
  def make_account_xml(msg)
    req = {"claim_accountv2req" => msg }
    h = req["claim_accountv2req"]
    h["Request_Number"] = "01"
    res = http_post(@conf,"/api01rv2/claimaccountv2",req.to_json)
    unless res.code == "200"
      raise "api /api01rv2/claimaccountv2 error #{res.code}"
    end
    xml = embed_account_xml(res.body)
  end
end
