#!/usr/bin/ruby
# coding: utf-8

require 'date'

module Orca

  class Wareki

    def initialize(symd = Time.now.strftime('%Y%m%d'))
      @ymd = symd.delete('-')
      @wareki = Date.strptime(@ymd,'%Y%m%d').jisx0301.gsub(/([A-Z\.])0/,'\1 ')
      @wday = Date.strptime(@ymd,'%Y%m%d').wday
    end

    def gengoA
      @wareki[0]
    end

    def gengoN
      hash={ 'M' => '明治', 'T' => '大正', 'S' => '昭和', 'H' => '平成' }
      @wareki[0].gsub(/^[#{hash.keys}]/,hash)
    end

    def year_w
      @wareki[1,2].to_i
    end

    def year_s
      @ymd[0,4].to_i
    end

    def month
      @ymd[4,2].to_i
    end

    def day
      @ymd[6,2].to_i
    end

    def wareki_a
      ('%s%2d.%2d.%2d' % [gengoA, year_w, month, day])
    end

    def wareki_n
      ('%s%2d年%2d月%2d日' % [gengoN, year_w, month, day]).tr('0-9 ','０-９　')
    end

    def wday
      @wday
    end

    def wday_n
      ['日','月','火','水','木','金','土'][@wday]
    end

    def age(baseYmd = Time.new.strftime('%Y%m%d'))
      d1 = @ymd.to_i
      d2 = baseYmd.delete('-').to_i
      n = (d2  - d1 ) / 10000
      n >= 0 ? n : nil
    end
    
    def self.wareki_a(symd  = Time.now.strftime('%Y%m%d'))
      a = new(symd)
      a.wareki_a
    end
    
    def self.wareki_n(symd  = Time.now.strftime('%Y%m%d'))
      n = new(symd)
      n.wareki_n
    end
  end
end
