# coding:utf-8
require 'thinreports'
require_relative '../lib/orca-wareki'

class Okusuri_techo

  LINE_SIZE = 22

  # call from print001.rb
  def export(fname,report_data,opt)
    tmpl = File.join(File.dirname(File.expand_path(__FILE__)),'okusuri_techo.tlf')
    report = ThinReports::Report.new layout: tmpl
    (Array(report_data['Reports']) + Array(report_data['Forms'])).each do |hash|
      note = []
      start_lines = []
      under_lines = []
    
      report.start_new_page
      data = hash['data']
      (Array(hash['data']['Prescription']) + Array(hash['data']['Rp'])).each do |rp|
        next if rp['Medical_Class'].nil?

        start_lines.push(note.size)
        rp['Medication'].each do |m|
          if !m['Name'].nil?
            amount = to_zen(to_num(m['Amount']).to_s) + m['Unit_Name'].to_s
            note.concat(edit_lines(m['Name'], amount))
          end
        end
        if ['21','22'].include?(rp['Medical_Class']) and "#{rp['Total_Amount_Flg']}#{rp['Not_Countable_Flg']}" != '1'
          count = to_zen(to_num("#{rp['Amount']}#{rp['Count']}").to_s) + rp['Unit_Name'].to_s
          note.concat(edit_lines(note.pop, count))
        end
        under_lines.push(note.size - 1)
      end
    
      note.push(data['Hospital']['Name'].join.to_s)
      note.push("ＴＥＬ：#{to_zen(data['Hospital']['PhoneNumber'].to_s)}")
    
      report.page.list.header.item(:patiant_name).value("#{data['Patient']['Name'].to_s}　様")
      ymd=Orca::Wareki.new("#{data['Prescription_Date']}#{data['Perform_Date']}")
      report.page.list.header.item(:perform_date).value("処方日：#{ymd.wareki_n}")
      report.page.list.header.item(:doctor_name).value("保険医名：#{data['Doctor']['Name'].to_s}")
    
      no = 0
      note.each_with_index do |t, i|
        report.list.add_row do |row|
          if start_lines.include?(i)
            no += 1
            row.item(:no).value('%2d)' % no)
          end
          if !under_lines.include?(i)
            row.item(:under_line).visible(false)
          end
          row.item(:note).value(t.gsub(/−/,'－'))
        end
      end
    end
    
    report.generate(filename: fname)
  end

  def to_num(v)
    ((float = Float(v)) && (float % 1.0 == 0) ? float.to_i : float) rescue v
  end
  
  def to_zen(v)
    v.tr('0-9\-\. ','０-９－．　')
  end
  
  def edit_lines(name,amount)
    lines = name.scan(/.{1,#{LINE_SIZE}}/)
    if lines.size == 0 or (lines.last + amount).size > LINE_SIZE
      lines.push(('　' * (LINE_SIZE - amount.size) + amount))
    else
      if amount != ''
        lines[-1] = lines.last + '　' * (LINE_SIZE - (lines.last + amount).size) + amount
      end
    end
  
    return lines
  end

end
