# coding : utf-8

require 'monpe'
require_relative '../lib/orca-string'
require_relative '../lib/orca-wareki'

class Karte_no3

  LIST_ROW_SIZE  = 40
  RED_FILE  = 'HCM33.red'

  def wareki_n(ymd)
    ymd.to_s.strip.empty? ? '' : Orca::Wareki.wareki_n(ymd)
  end

  def edit_patient_information(form, embed_data)

    form.set_layer_visible('LABEL', true)
    form.set_layer_visible('LINE', true)

    patient = @data['Patient'] || {}

    embed_data['PTNUM'] = patient['ID']
    embed_data['NAME'] = patient['Name'].to_s[0,25]
    embed_data['TANJYOBI'] = wareki_n(patient['BirthDate']) + '生'

    case patient['Sex']
    when '1'
      embed_data['SEX'] = '男'
    when '2'
      embed_data['SEX'] = '女'
    end

    embed_data['SRYKA'] = @data['Department_Name']

    unless @data['Order_Class'] == '2'
      embed_data['PAGE'] = @page.to_s
      unless @data['Perform_Month'].nil?
        embed_data['SRYYM'] = wareki_n("#{@data['Perform_Month']}-01")[0, 8] + '～'
      end
      embed_data['HKNSYUBETU'] = @data['Insurance_Name']
    end

  end

  def edit_form(offset_1)
  
    forms = Array.new
    form_dir = File.dirname(File.expand_path(__FILE__))
    red_file = File.join(form_dir, RED_FILE)
    form = Monpe::Report.new(red_file)
    embed_data = form.get_embed_data
    form.set_layer_visible('LABEL', false)
    form.set_layer_visible('LINE', false)

    if @data['Order_Class'] == '2'
      edit_patient_information(form, embed_data)
      form.set_embed_data(embed_data)
      return forms.push(form)
    end

    row_no = @data['Last_Row_Number'].to_i >= LIST_ROW_SIZE ? LIST_ROW_SIZE - 1 : @data['Last_Row_Number'].to_i
    perform_date = nil
    flg_embed_data = false
    Array(@data['Account_List']).delete_if(&:empty?).each do |row|
      edit_patient_information(form, embed_data) if row_no == 0
      embed_data["A-TBL[#{row_no}].NUM"] = "#{row_no + 1}"
      unless perform_date == row['Perform_Date'] or row['Perform_Date'].nil?
        embed_data["A-TBL[#{row_no}].SRYMD"] = Orca::Wareki.wareki_a(row['Perform_Date'])[4, 5]
        perform_date = row['Perform_Date']
      end

      embed_data["A-TBL[#{row_no}].NAIYO[0]"] = row['Consultation']
      embed_data["A-TBL[#{row_no}].NAIYO[1]"] = row['Medication']
      embed_data["A-TBL[#{row_no}].NAIYO[2]"] = row['Injection']
      embed_data["A-TBL[#{row_no}].NAIYO[3]"] = row['Treatment_Operation']
      embed_data["A-TBL[#{row_no}].NAIYO[4]"] = row['Examination']
      embed_data["A-TBL[#{row_no}].NAIYO[5]"] = row['Diagnostic_Imaging']
      embed_data["A-TBL[#{row_no}].NAIYO[6]"] = row['Other']
      embed_data["A-TBL[#{row_no}].NAIYO[7]"] = row['Total_Point']
      embed_data["A-TBL[#{row_no}].NAIYO[8]"] = row['Total_Copayment']
      embed_data["A-TBL[#{row_no}].NAIYO[9]"] = row['Own_Expence']
      embed_data["A-TBL[#{row_no}].BIKOU"] = row['Memo']

      row_no += 1
      flg_embed_data = true
      if row_no >= LIST_ROW_SIZE
        form.set_embed_data(embed_data) 
        forms.push(form)
        row_no = 0
        perform_date = nil
        form = Monpe::Report.new(red_file)
        embed_data = form.get_embed_data
        flg_embed_data = false
        form.set_layer_visible('LABEL', false)
        form.set_layer_visible('LINE', false)
        @page += 1
      end
      form.set_offset(*offset_1) if offset_1
    end

    if flg_embed_data
      form.set_embed_data(embed_data) 
      forms.push(form)
    end
    return forms
  end

  def export(pdf_file, form_data, opt)
    forms = Array.new
    @opt = opt

    offset_set = opt[:pr_conf][:offset_settings]
    if offset_set
      offset_1 =  offset_set[RED_FILE.to_sym]
    else
      offset_1 = nil
    end

    form_data['Forms'].each do |hash|
      @data = hash['data']
      @page = @data['Last_Page_Number'].to_i == 0 ? 1 : @data['Last_Page_Number'].to_i
      forms.concat(edit_form(offset_1))
    end
    Monpe.export(forms, pdf_file)
  end
end

=begin
pdf_file = "karte_no3.pdf"
form_data = <<EOF
{
  "Forms": [
{
  "data": {
}
  ]
}
EOF

conf = { :api_user => 'ormaster',
         :api_key => 'ormaster',
         :api_server => 'localhost',
         :api_port => 8000 }
opt = Hash.new
opt[:conf] = conf
require 'json'
form = Karte_no3.new
form.export(pdf_file, JSON.parse(form_data), opt)
=end
