# coding : utf-8

require 'monpe'
require_relative '../lib/orca-wareki'

class Yoyakulist

  LINE_ROW_SIZE  = 34
  RED_FILE  = 'HC14.red'

  def wareki_n(ymd)
    ymd.to_s.strip.empty? ? '' : Orca::Wareki.wareki_n(ymd)
  end

  def export(fname, form_data, opt)

    offset_set = opt[:pr_conf][:offset_settings]
    if offset_set
      offset_1 =  offset_set[RED_FILE.to_sym]
    else
      offset_1 = nil
    end

    forms = []

    form_data['Forms'].each do |hash|
      @data = hash['data']
      ary = edit_ary
      ary.each_slice(LINE_ROW_SIZE).each.with_index(1) do |ary, page_no|
        f = edit_page(ary, page_no)
        f.set_offset(*offset_1) if offset_1
        forms << f
      end
    end

    forms << edit_page if forms.size == 0

    Monpe.export(forms, fname)
  end

  def edit_ary
    ary = Array.new
    Array(@data['Appointment_List']).reject{|h| h['Time'].nil?}.each.with_index do |hash, i|
      hash['No'] = i + 1
      ary.push(hash)
    end
    return ary
  end

  def edit_page(ary = nil, page_no = nil )
    red = File.join(File.dirname(File.expand_path(__FILE__)), RED_FILE)
    form = Monpe::Report.new(red)
    embed_data = form.get_embed_data

    unless ary.nil?
      set_head(embed_data, page_no)
      Array(ary).each_with_index do |hash, i|
        set_list(embed_data, hash, i)
      end
    end

    form.set_embed_data(embed_data)
    return form
  end

  def set_head(embed_data, page_no)
    embed_data['PAGE'] = page_no.to_s
    embed_data['SRYYMD'] = wareki_n(@data['Perform_Date'])
    title = @data['Order_Class'] == '1' ? '予約一覧表' : '来院一覧表'
    embed_data['TITLE'] = title
  end

  def set_list(embed_data, hash, i)
    medical = hash['Medical_Information'] || {}
    doctor = hash['Doctor'] || {}
    patient = hash['Patient'] || {}

    embed_data["NUM[#{i}]"] = hash['No'].to_s
    embed_data["YYKTIME[#{i}]"] = hash['Time']
    embed_data["SRYKA[#{i}]"] = hash['Department_Name'][0,10]
    embed_data["DRNAME[#{i}]"] = doctor['Name'][0,8]
    embed_data["NAME[#{i}]"] = patient['TemporaryName'][0,10]
    embed_data["PTNUM[#{i}]"] = patient['ID']
    embed_data["RENRAKU[#{i}]"] = hash['Contact_Name'][0,10]
    embed_data["YOYAKUNAIY[#{i}]"] = hash['Appointment_Name'][0,8]
    embed_data["RAIIN[#{i}]"] = '済' if hash['Visit_Flg'] == '1'
    embed_data["SRYNAIYO[#{i}]"] = medical['Name'][0,5]
  end

end

=begin
pdf_file = "yoyakulist.pdf"

form_data = <<EOF
{
  "Forms": [
    {
      "data": {
      }
    }
  ]
}
EOF

conf = { :api_user => 'ormaster',
         :api_key => 'ormaster',
         :api_server => 'localhost',
         :api_port => 8000 }
opt = Hash.new
opt[:conf] = conf
require 'json'
form = Yoyakulist.new
form.export(pdf_file, JSON.parse(form_data), opt)
=end

